<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>ombs-OnlineMovieBookingSystem: src/mongodbhandler/mongodb_handler.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">ombs-OnlineMovieBookingSystem
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_da1c6a6595f2982f441602eb3201664d.html">mongodbhandler</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">mongodb_handler.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="mongodb__handler_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;mutex&gt;</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="preprocessor">#include &quot;SimpleJSON/json.hpp&quot;</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="preprocessor">#include &quot;mongocxx/client.hpp&quot;</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="preprocessor">#include &quot;mongocxx/database.hpp&quot;</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#include &quot;mongocxx/uri.hpp&quot;</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="preprocessor">#include &quot;mongocxx/instance.hpp&quot;</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceomsb.html">omsb</a></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;{</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160; </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#ifndef NDEBUG</span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;  <span class="comment">// for local mongodb (for dev and debug  setups)</span></div>
<div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="namespaceomsb.html#ae9fa713289adf0403b4e9e4933119aa5">   27</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#ae9fa713289adf0403b4e9e4933119aa5">ombsMongoDbUri</a>[] = <span class="stringliteral">&quot;mongodb://0.0.0.0&quot;</span>;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#else</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;  <span class="comment">// for docker-compose production release with mongodb in a docker container</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#ae9fa713289adf0403b4e9e4933119aa5">ombsMongoDbUri</a>[] = <span class="stringliteral">&quot;mongodb://mongo&quot;</span>;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="preprocessor">#endif</span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="namespaceomsb.html#a04aab5d8b25fb4d8a0d290be9a1674fb">   34</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#a04aab5d8b25fb4d8a0d290be9a1674fb">ombsOmbsDatabaseName</a>[] = <span class="stringliteral">&quot;ombs_database&quot;</span>;</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="namespaceomsb.html#a6db4d98839f154bd725bbab9217f7169">   35</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#a6db4d98839f154bd725bbab9217f7169">ombsMovieShowsCollectionName</a>[] = <span class="stringliteral">&quot;movieshows&quot;</span>;</div>
<div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="namespaceomsb.html#ad228ec140c97bd390aa3254f377e4b54">   36</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#ad228ec140c97bd390aa3254f377e4b54">ombsTheatersCollectionName</a>[] = <span class="stringliteral">&quot;theaters&quot;</span>;</div>
<div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="namespaceomsb.html#a6e782e5b847709cd85efc1dadb6526bf">   37</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#a6e782e5b847709cd85efc1dadb6526bf">ombsMoviesCollectionName</a>[] = <span class="stringliteral">&quot;movies&quot;</span>;</div>
<div class="line"><a name="l00038"></a><span class="lineno"><a class="line" href="namespaceomsb.html#a8978065622ebccb03944482bae950286">   38</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#a8978065622ebccb03944482bae950286">ombsSeatsCollectionName</a>[] = <span class="stringliteral">&quot;seats&quot;</span>;</div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="namespaceomsb.html#ae8e19c46fe6cde2ad6d941b11cc46701">   39</a></span>&#160;  constexpr <span class="keywordtype">char</span> <a class="code" href="namespaceomsb.html#ae8e19c46fe6cde2ad6d941b11cc46701">ombsBookingsCollectionName</a>[] = <span class="stringliteral">&quot;bookings&quot;</span>;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="namespaceomsb.html#a5ecca3d4606ecd606a2d64c9a6628387">   45</a></span>&#160;  <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="namespaceomsb.html#a5ecca3d4606ecd606a2d64c9a6628387">NUMBER_OF_SEATS_FOR_A_MOVIE_IN_THEATER</a> = 20;</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00051"></a><span class="lineno"><a class="line" href="namespaceomsb.html#a822a40e494a03b196294e7333981ab59">   51</a></span>&#160;  <span class="keyword">inline</span> <a class="code" href="namespaceomsb.html#a822a40e494a03b196294e7333981ab59">mongocxx::instance</a> <a class="code" href="namespaceomsb.html#a822a40e494a03b196294e7333981ab59">instance</a>;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="namespaceomsb.html#aa4e72116c77b65c50a00b136491fafec">   57</a></span>&#160;  <span class="keyword">inline</span> std::mutex <a class="code" href="namespaceomsb.html#aa4e72116c77b65c50a00b136491fafec">seats_booking_mutex_lock</a>;</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160; </div>
<div class="line"><a name="l00063"></a><span class="lineno"><a class="line" href="classomsb_1_1_mongo_db_handler.html">   63</a></span>&#160;  <span class="keyword">class </span><a class="code" href="classomsb_1_1_mongo_db_handler.html">MongoDbHandler</a></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;  {</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;  <span class="keyword">public</span>:</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <a class="code" href="classomsb_1_1_mongo_db_handler.html#a668896d72174ab8937709240222cdd92">MongoDbHandler</a>();</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160; </div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classomsb_1_1_mongo_db_handler.html#a4bf4aeb89d91622ff52e343bec655d4e">AddTheaterToDb</a>(<span class="keyword">const</span> std::string &amp;theater_name);</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160; </div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classomsb_1_1_mongo_db_handler.html#ae76b951defd231273ee70264e82ca6d0">AddMovieToDb</a>(<span class="keyword">const</span> std::string &amp;movie_title);</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160; </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    json::JSON <a class="code" href="classomsb_1_1_mongo_db_handler.html#a52f86fab00ed69982149f8799215cab7">GetAllTheaters</a>();</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    json::JSON <a class="code" href="classomsb_1_1_mongo_db_handler.html#af8488e63e677c8e294340086f81d0c02">GetAllMovies</a>();</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160; </div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classomsb_1_1_mongo_db_handler.html#a7866c1d3c4d63794358836dd7f9b328e">AddMovieShowToDb</a>(<span class="keyword">const</span> std::string &amp;theater_id, <span class="keyword">const</span> std::string &amp;movie_id);</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160; </div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    json::JSON <a class="code" href="classomsb_1_1_mongo_db_handler.html#a31c4ea013fc2b2d63be2af01d52b00f7">GetAllMovieShows</a>();</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160; </div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    json::JSON <a class="code" href="classomsb_1_1_mongo_db_handler.html#a921491af6cf6a169c5945bc69e9808b9">GetTheatersByMovie</a>(<span class="keyword">const</span> std::string &amp;movie_id);</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160; </div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    json::JSON <a class="code" href="classomsb_1_1_mongo_db_handler.html#add87e37b40c98f6bfe2ac280d4111057">GetSeatsByMovieAndByTheater</a>(<span class="keyword">const</span> std::string &amp;movie_id, <span class="keyword">const</span> std::string &amp;theater_id);</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160; </div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classomsb_1_1_mongo_db_handler.html#a667615c575c910d11120bb24ac5c37d7">BookSeats</a>(<span class="keyword">const</span> std::vector&lt;std::string&gt; &amp;seatsIdsList);</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160; </div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classomsb_1_1_mongo_db_handler.html#a3e1ce7d6750122392fcde924d710cee5">DropDatabase</a>();</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160; </div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;  <span class="keyword">private</span>:</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    mongocxx::uri uri;</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    mongocxx::client client;</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    mongocxx::database db;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160; </div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    <span class="keywordtype">bool</span> BookSingleSeat(<span class="keyword">const</span> std::string &amp;seat_id, std::string &amp;show_id, <span class="keyword">const</span> std::string &amp;booking_id);</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160; </div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    std::string FindShowIdBySeat(<span class="keyword">const</span> std::string &amp;seat_id);</div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160; </div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    <span class="keywordtype">bool</span> InsertSeatToBooking(<span class="keyword">const</span> std::string &amp;seat_id, <span class="keyword">const</span> std::string &amp;book_id);</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160; </div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    std::string CreateBooking(<span class="keyword">const</span> std::string &amp;show_id, <span class="keyword">const</span> std::string &amp;user_email = <span class="stringliteral">&quot;nicolas.haddad80@gmail.com&quot;</span>);</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160; </div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;  }; <span class="comment">// Class</span></div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;} <span class="comment">// namespace omsb</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespaceomsb_html_a04aab5d8b25fb4d8a0d290be9a1674fb"><div class="ttname"><a href="namespaceomsb.html#a04aab5d8b25fb4d8a0d290be9a1674fb">omsb::ombsOmbsDatabaseName</a></div><div class="ttdeci">constexpr char ombsOmbsDatabaseName[]</div><div class="ttdef"><b>Definition:</b> mongodb_handler.hpp:34</div></div>
<div class="ttc" id="anamespaceomsb_html_aa4e72116c77b65c50a00b136491fafec"><div class="ttname"><a href="namespaceomsb.html#aa4e72116c77b65c50a00b136491fafec">omsb::seats_booking_mutex_lock</a></div><div class="ttdeci">std::mutex seats_booking_mutex_lock</div><div class="ttdoc">this a lock mutex to avoid averbooking when we book a list of seats</div><div class="ttdef"><b>Definition:</b> mongodb_handler.hpp:57</div></div>
<div class="ttc" id="aclassomsb_1_1_mongo_db_handler_html_a3e1ce7d6750122392fcde924d710cee5"><div class="ttname"><a href="classomsb_1_1_mongo_db_handler.html#a3e1ce7d6750122392fcde924d710cee5">omsb::MongoDbHandler::DropDatabase</a></div><div class="ttdeci">bool DropDatabase()</div><div class="ttdoc">used by admin user to reset datbase.</div><div class="ttdef"><b>Definition:</b> mongodb_handler.cpp:409</div></div>
<div class="ttc" id="anamespaceomsb_html_a6e782e5b847709cd85efc1dadb6526bf"><div class="ttname"><a href="namespaceomsb.html#a6e782e5b847709cd85efc1dadb6526bf">omsb::ombsMoviesCollectionName</a></div><div class="ttdeci">constexpr char ombsMoviesCollectionName[]</div><div class="ttdef"><b>Definition:</b> mongodb_handler.hpp:37</div></div>
<div class="ttc" id="anamespaceomsb_html_ad228ec140c97bd390aa3254f377e4b54"><div class="ttname"><a href="namespaceomsb.html#ad228ec140c97bd390aa3254f377e4b54">omsb::ombsTheatersCollectionName</a></div><div class="ttdeci">constexpr char ombsTheatersCollectionName[]</div><div class="ttdef"><b>Definition:</b> mongodb_handler.hpp:36</div></div>
<div class="ttc" id="aclassomsb_1_1_mongo_db_handler_html_ae76b951defd231273ee70264e82ca6d0"><div class="ttname"><a href="classomsb_1_1_mongo_db_handler.html#ae76b951defd231273ee70264e82ca6d0">omsb::MongoDbHandler::AddMovieToDb</a></div><div class="ttdeci">bool AddMovieToDb(const std::string &amp;movie_title)</div><div class="ttdoc">creates a new movie in ombs database.</div><div class="ttdef"><b>Definition:</b> mongodb_handler.cpp:18</div></div>
<div class="ttc" id="aclassomsb_1_1_mongo_db_handler_html_a52f86fab00ed69982149f8799215cab7"><div class="ttname"><a href="classomsb_1_1_mongo_db_handler.html#a52f86fab00ed69982149f8799215cab7">omsb::MongoDbHandler::GetAllTheaters</a></div><div class="ttdeci">json::JSON GetAllTheaters()</div><div class="ttdoc">Get all present theaters in the database.</div><div class="ttdef"><b>Definition:</b> mongodb_handler.cpp:92</div></div>
<div class="ttc" id="aclassomsb_1_1_mongo_db_handler_html_a7866c1d3c4d63794358836dd7f9b328e"><div class="ttname"><a href="classomsb_1_1_mongo_db_handler.html#a7866c1d3c4d63794358836dd7f9b328e">omsb::MongoDbHandler::AddMovieShowToDb</a></div><div class="ttdeci">bool AddMovieShowToDb(const std::string &amp;theater_id, const std::string &amp;movie_id)</div><div class="ttdoc">creates a new movie show in ombs database. By default, 20 avaialble seats are created for a given cou...</div><div class="ttdef"><b>Definition:</b> mongodb_handler.cpp:109</div></div>
<div class="ttc" id="aclassomsb_1_1_mongo_db_handler_html_a4bf4aeb89d91622ff52e343bec655d4e"><div class="ttname"><a href="classomsb_1_1_mongo_db_handler.html#a4bf4aeb89d91622ff52e343bec655d4e">omsb::MongoDbHandler::AddTheaterToDb</a></div><div class="ttdeci">bool AddTheaterToDb(const std::string &amp;theater_name)</div><div class="ttdoc">creates a new theater in ombs database</div><div class="ttdef"><b>Definition:</b> mongodb_handler.cpp:61</div></div>
<div class="ttc" id="anamespaceomsb_html_ae9fa713289adf0403b4e9e4933119aa5"><div class="ttname"><a href="namespaceomsb.html#ae9fa713289adf0403b4e9e4933119aa5">omsb::ombsMongoDbUri</a></div><div class="ttdeci">constexpr char ombsMongoDbUri[]</div><div class="ttdef"><b>Definition:</b> mongodb_handler.hpp:27</div></div>
<div class="ttc" id="anamespaceomsb_html"><div class="ttname"><a href="namespaceomsb.html">omsb</a></div><div class="ttdef"><b>Definition:</b> http_server.cpp:7</div></div>
<div class="ttc" id="ahttp__server_8hpp_html"><div class="ttname"><a href="http__server_8hpp.html">http_server.hpp</a></div></div>
<div class="ttc" id="amain_8cpp_html_ae66f6b31b5ad750f1fe042a706a4e3d4"><div class="ttname"><a href="main_8cpp.html#ae66f6b31b5ad750f1fe042a706a4e3d4">main</a></div><div class="ttdeci">int main()</div><div class="ttdoc">this is the server main application it just creating then starting ombs server</div><div class="ttdef"><b>Definition:</b> main.cpp:10</div></div>
<div class="ttc" id="aclassomsb_1_1_mongo_db_handler_html_add87e37b40c98f6bfe2ac280d4111057"><div class="ttname"><a href="classomsb_1_1_mongo_db_handler.html#add87e37b40c98f6bfe2ac280d4111057">omsb::MongoDbHandler::GetSeatsByMovieAndByTheater</a></div><div class="ttdeci">json::JSON GetSeatsByMovieAndByTheater(const std::string &amp;movie_id, const std::string &amp;theater_id)</div><div class="ttdoc">Get all availabe seats fior a given movie in given theater.</div><div class="ttdef"><b>Definition:</b> mongodb_handler.cpp:303</div></div>
<div class="ttc" id="anamespaceomsb_html_a8978065622ebccb03944482bae950286"><div class="ttname"><a href="namespaceomsb.html#a8978065622ebccb03944482bae950286">omsb::ombsSeatsCollectionName</a></div><div class="ttdeci">constexpr char ombsSeatsCollectionName[]</div><div class="ttdef"><b>Definition:</b> mongodb_handler.hpp:38</div></div>
<div class="ttc" id="anamespaceomsb_html_a6db4d98839f154bd725bbab9217f7169"><div class="ttname"><a href="namespaceomsb.html#a6db4d98839f154bd725bbab9217f7169">omsb::ombsMovieShowsCollectionName</a></div><div class="ttdeci">constexpr char ombsMovieShowsCollectionName[]</div><div class="ttdef"><b>Definition:</b> mongodb_handler.hpp:35</div></div>
<div class="ttc" id="aclassomsb_1_1_mongo_db_handler_html_a921491af6cf6a169c5945bc69e9808b9"><div class="ttname"><a href="classomsb_1_1_mongo_db_handler.html#a921491af6cf6a169c5945bc69e9808b9">omsb::MongoDbHandler::GetTheatersByMovie</a></div><div class="ttdeci">json::JSON GetTheatersByMovie(const std::string &amp;movie_id)</div><div class="ttdoc">Get all Theaters that are showing a particular movie.</div><div class="ttdef"><b>Definition:</b> mongodb_handler.cpp:254</div></div>
<div class="ttc" id="aclassomsb_1_1_mongo_db_handler_html_af8488e63e677c8e294340086f81d0c02"><div class="ttname"><a href="classomsb_1_1_mongo_db_handler.html#af8488e63e677c8e294340086f81d0c02">omsb::MongoDbHandler::GetAllMovies</a></div><div class="ttdeci">json::JSON GetAllMovies()</div><div class="ttdoc">Get all present movies in the database.</div><div class="ttdef"><b>Definition:</b> mongodb_handler.cpp:45</div></div>
<div class="ttc" id="aclassomsb_1_1_mongo_db_handler_html_a31c4ea013fc2b2d63be2af01d52b00f7"><div class="ttname"><a href="classomsb_1_1_mongo_db_handler.html#a31c4ea013fc2b2d63be2af01d52b00f7">omsb::MongoDbHandler::GetAllMovieShows</a></div><div class="ttdeci">json::JSON GetAllMovieShows()</div><div class="ttdoc">Get the All Movie Shows that has at least one avaialbale seat for booking.</div><div class="ttdef"><b>Definition:</b> mongodb_handler.cpp:204</div></div>
<div class="ttc" id="anamespaceomsb_html_ae8e19c46fe6cde2ad6d941b11cc46701"><div class="ttname"><a href="namespaceomsb.html#ae8e19c46fe6cde2ad6d941b11cc46701">omsb::ombsBookingsCollectionName</a></div><div class="ttdeci">constexpr char ombsBookingsCollectionName[]</div><div class="ttdef"><b>Definition:</b> mongodb_handler.hpp:39</div></div>
<div class="ttc" id="aclassomsb_1_1_mongo_db_handler_html"><div class="ttname"><a href="classomsb_1_1_mongo_db_handler.html">omsb::MongoDbHandler</a></div><div class="ttdoc">this is the class to allow creation of controller objects as needed for ombs mongodb database</div><div class="ttdef"><b>Definition:</b> mongodb_handler.hpp:63</div></div>
<div class="ttc" id="aclassomsb_1_1_http_server_html"><div class="ttname"><a href="classomsb_1_1_http_server.html">omsb::HttpServer</a></div><div class="ttdoc">this the class that handels user REST API requests. we only need to create one object abd start serve...</div><div class="ttdef"><b>Definition:</b> http_server.hpp:53</div></div>
<div class="ttc" id="anamespaceomsb_html_a5ecca3d4606ecd606a2d64c9a6628387"><div class="ttname"><a href="namespaceomsb.html#a5ecca3d4606ecd606a2d64c9a6628387">omsb::NUMBER_OF_SEATS_FOR_A_MOVIE_IN_THEATER</a></div><div class="ttdeci">const int NUMBER_OF_SEATS_FOR_A_MOVIE_IN_THEATER</div><div class="ttdoc">Assume that available seats number for a couple of given thrater and movie is 20.</div><div class="ttdef"><b>Definition:</b> mongodb_handler.hpp:45</div></div>
<div class="ttc" id="aclassomsb_1_1_http_server_html_a790f33952f28a1045959d77f59550133"><div class="ttname"><a href="classomsb_1_1_http_server.html#a790f33952f28a1045959d77f59550133">omsb::HttpServer::StartServer</a></div><div class="ttdeci">void StartServer()</div><div class="ttdoc">Starts the server after endpoints have been initialized.</div><div class="ttdef"><b>Definition:</b> http_server.cpp:17</div></div>
<div class="ttc" id="anamespaceomsb_html_a822a40e494a03b196294e7333981ab59"><div class="ttname"><a href="namespaceomsb.html#a822a40e494a03b196294e7333981ab59">omsb::instance</a></div><div class="ttdeci">mongocxx::instance instance</div><div class="ttdoc">instance to mongodb driver, should be declared only once in all the application.</div><div class="ttdef"><b>Definition:</b> mongodb_handler.hpp:51</div></div>
<div class="ttc" id="amongodb__handler_8hpp_html"><div class="ttname"><a href="mongodb__handler_8hpp.html">mongodb_handler.hpp</a></div></div>
<div class="ttc" id="aclassomsb_1_1_mongo_db_handler_html_a668896d72174ab8937709240222cdd92"><div class="ttname"><a href="classomsb_1_1_mongo_db_handler.html#a668896d72174ab8937709240222cdd92">omsb::MongoDbHandler::MongoDbHandler</a></div><div class="ttdeci">MongoDbHandler()</div><div class="ttdoc">Construct a new Mongo Db Handler object.</div><div class="ttdef"><b>Definition:</b> mongodb_handler.cpp:10</div></div>
<div class="ttc" id="aclassomsb_1_1_mongo_db_handler_html_a667615c575c910d11120bb24ac5c37d7"><div class="ttname"><a href="classomsb_1_1_mongo_db_handler.html#a667615c575c910d11120bb24ac5c37d7">omsb::MongoDbHandler::BookSeats</a></div><div class="ttdeci">bool BookSeats(const std::vector&lt; std::string &gt; &amp;seatsIdsList)</div><div class="ttdoc">allow the user to book a list of available seats.</div><div class="ttdef"><b>Definition:</b> mongodb_handler.cpp:343</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
